(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/cdk/portal'), require('@angular/cdk/overlay'), require('@angular/material/button'), require('@angular/cdk/coercion'), require('rxjs'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('material-community-components/timer-picker', ['exports', '@angular/core', '@angular/common', '@angular/cdk/portal', '@angular/cdk/overlay', '@angular/material/button', '@angular/cdk/coercion', 'rxjs', '@angular/forms'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['material-community-components'] = global['material-community-components'] || {}, global['material-community-components']['timer-picker'] = {}), global.ng.core, global.ng.common, global.ng.cdk.portal, global.ng.cdk.overlay, global.ng.material.button, global.ng.cdk.coercion, global.rxjs, global.ng.forms));
}(this, (function (exports, core, common, portal, overlay, button, coercion, rxjs, forms) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * contants to create timer with HOURS or MINUTES
     */
    var HOURS = ['12', '11', '1', '10', '2', '9', '3', '8', '4', '7', '5', '6'];
    var HOURS24 = ['00', '23', '13', '22', '14', '21', '15', '20', '16', '19', '17', '18'];
    var MINUTES = [
        '00',
        '55',
        '05',
        '50',
        '10',
        '45',
        '15',
        '40',
        '20',
        '35',
        '25',
        '30',
    ];

    var MccTimerPickerComponent = /** @class */ (function () {
        function MccTimerPickerComponent(changeDetectorRef) {
            this.changeDetectorRef = changeDetectorRef;
            /**
             * Receive selected _hour after confirm
             */
            this._selectedHour = '12';
            /**
             * Receive selected _minute after confirm
             */
            this._selectedMinute = '00';
            /**
             * Receive selected _period after confirm
             */
            this._selectedPeriod = 'am';
            this._clock = new rxjs.BehaviorSubject(HOURS);
            this._focus = 'hour';
            this._hour = '12';
            this._minute = '00';
            this._period = 'am';
            this._hideButtons = false;
            /**
             * Format of the hour to be emited on confirm
             */
            this.format = '12';
            this.min = '00:00 am';
            this.max = '12:00 pm';
            /**
             * Change btnCancel label
             */
            this.btnCancel = 'Cancel';
            /**
             * Change btnConfirm label
             */
            this.btnConfirm = 'Confirm';
            /**
             * Event emited when confirm button is pressed.
             * If buttons are hidden, the event is emited when value is changed
             */
            this.selected = new core.EventEmitter();
            /**
             * Set to true when timer picker have been connected with another component
             */
            this.connected = false;
        }
        Object.defineProperty(MccTimerPickerComponent.prototype, "clock$", {
            /**
             * Current value (hour/minute) to create the clock
             */
            get: function () {
                return this._clock.asObservable();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MccTimerPickerComponent.prototype, "hours24", {
            /**
             * Return hours in 24h format
             */
            get: function () {
                return HOURS24;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MccTimerPickerComponent.prototype, "focus", {
            /**
             * Type there is in focus (hour/minute)
             */
            get: function () {
                return this._focus;
            },
            set: function (value) {
                if (value !== this._focus) {
                    this._focus = value;
                    this._clock.next(this._focus === 'hour' ? HOURS : MINUTES);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MccTimerPickerComponent.prototype, "isOpen", {
            /**
             * State of the overlay
             */
            get: function () {
                return this._isOpen;
            },
            set: function (value) {
                this._isOpen = coercion.coerceBooleanProperty(value);
                this.changeDetectorRef.detectChanges();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MccTimerPickerComponent.prototype, "hour", {
            /**
             * Return temporary selected hour (const HOURS)
             */
            get: function () {
                return this._hour;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MccTimerPickerComponent.prototype, "needsSpacer", {
            /**
             * Checks if hour has only one digit
             */
            get: function () {
                return parseInt(this._hour, 10) < 10;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MccTimerPickerComponent.prototype, "minute", {
            /**
             * Return temporary selected minute (const MINUTES)
             */
            get: function () {
                return this._minute;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MccTimerPickerComponent.prototype, "period", {
            /**
             * Return temporary selected period (am/pm)
             */
            get: function () {
                return this._period;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(MccTimerPickerComponent.prototype, "hideButtons", {
            get: function () {
                return this._hideButtons;
            },
            /**
             * Hide Confirm and Cancel buttons
             */
            set: function (value) {
                this._hideButtons = coercion.coerceBooleanProperty(value);
            },
            enumerable: false,
            configurable: true
        });
        /**
         * Return timer option class to create line between the middle of the clock and
         * the option
         */
        MccTimerPickerComponent.prototype.getSelectedClass = function () {
            var _this = this;
            var name = 'selected-index-';
            if (this.focus === 'hour') {
                // convert to number
                var hour = parseInt(this.hour, 10);
                // check if hour is mid night or afternoon in 24h format
                if (hour === 0 || hour > 12) {
                    name += HOURS24.findIndex(function (h) { return h === _this.hour; });
                    name += ' hour-format-24';
                }
                else {
                    name += HOURS.findIndex(function (h) { return h === _this.hour; });
                }
            }
            else {
                name += MINUTES.findIndex(function (m) { return m === _this.minute; });
            }
            return name;
        };
        /**
         * Select option from the clock.
         */
        MccTimerPickerComponent.prototype.select = function (value) {
            if (this.focus === 'hour') {
                this._hour = value;
                this.focus = 'min';
            }
            else {
                this._minute = value;
                // if buttons are hidden, emit new event when value is changed
                if (this._hideButtons) {
                    this.confirmSelectedTime();
                }
            }
        };
        /**
         * Returns array containing time, hour and period fragments from time string
         */
        MccTimerPickerComponent.prototype.parseTimeInput = function (time) {
            var parsed = time.split(/\s|:/).map(function (fragment, index) {
                return index === 2 ? fragment : parseInt(fragment, 10);
            });
            if (parsed.length === 2) {
                // assume we are using 24 hour time format
                var hours = parsed[0];
                if (hours > 11) {
                    parsed[0] = hours - 12;
                    parsed.push('pm');
                }
                else {
                    parsed.push('am');
                }
            }
            return parsed;
        };
        /**
         * Returns true if option value is not valid
         */
        MccTimerPickerComponent.prototype.isOptionDisabled = function (value) {
            var _a = __read(this.parseTimeInput(this.min), 3), minHour = _a[0], minMinutes = _a[1], minPeriod = _a[2];
            var _b = __read(this.parseTimeInput(this.max), 3), maxHour = _b[0], maxMinutes = _b[1], maxPeriod = _b[2];
            var optionValue = parseInt(value, 10);
            var selectedHour = parseInt(this._hour, 10);
            var selectedPeriod = this._period;
            if (this.focus === 'hour') {
                if (optionValue < minHour && selectedPeriod === minPeriod) {
                    return true;
                }
                else if (optionValue > maxHour && selectedPeriod === maxPeriod) {
                    return true;
                }
            }
            else {
                if (selectedHour === minHour && selectedPeriod === minPeriod && optionValue < minMinutes) {
                    return true;
                }
                else if (selectedHour === maxHour && selectedPeriod === maxPeriod && optionValue > maxMinutes) {
                    return true;
                }
            }
            return false;
        };
        /**
         * Change period of the clock
         */
        MccTimerPickerComponent.prototype.changePeriod = function (period) {
            this._period = period;
            // if buttons are hidden, emit new event when value is changed
        };
        /**
         * Update selected color, close the panel and notify the user
         */
        MccTimerPickerComponent.prototype.backdropClick = function () {
            if (this._hideButtons) {
                this.confirmSelectedTime();
            }
            else {
                this.cancelSelection();
            }
        };
        /**
         * Change values to last confirm select time
         */
        MccTimerPickerComponent.prototype.cancelSelection = function () {
            this._hour = this._selectedHour;
            this._minute = this._selectedMinute;
            this._period = this._selectedPeriod;
            this.isOpen = false;
        };
        /**
         * Set new values of time and emit new event with the formatted timer
         */
        MccTimerPickerComponent.prototype.confirmSelectedTime = function () {
            this._selectedHour = this.hour;
            this._selectedMinute = this.minute;
            this._selectedPeriod = this.period;
            // format string to emit selected time
            var formated;
            if (this.format === '12') {
                formated = this.hour + ":" + this.minute + " " + this.period;
            }
            else {
                var hour = this.hour;
                if (this.period === 'pm') {
                    hour = "" + (parseInt(hour, 10) + 12);
                }
                formated = hour + ":" + this.minute;
            }
            this.selected.emit(formated);
            this.isOpen = false;
        };
        return MccTimerPickerComponent;
    }());
    MccTimerPickerComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'mcc-timer-picker',
                    template: "<!-- show component inside overlay -->\n<ng-container *ngIf=\"connected\">\n  <ng-template cdkConnectedOverlay cdkConnectedOverlayHasBackdrop cdkConnectedOverlayBackdropClass=\"mcc-timer-picker-backdrop\" [cdkConnectedOverlayOrigin]=\"trigger\"\n    [cdkConnectedOverlayOpen]=\"isOpen\" (backdropClick)=\"backdropClick()\">\n\n    <ng-template [cdkPortalOutlet]=\"panelComponent\"></ng-template>\n\n  </ng-template>\n</ng-container>\n\n<ng-template *ngIf=\"!connected\" [cdkPortalOutlet]=\"panelComponent\"></ng-template>\n\n<ng-template cdkPortal #panelComponent=\"cdkPortal\">\n  <div class=\"mcc-timer-picker-overlay mat-elevation-z4\" role=\"dialog\" aria-label=\"Timer picker\">\n\n    <div class=\"mcc-timer-picker-header mat-primary\">\n      <div class=\"mcc-timer-picker-header-clock\">\n        <button mat-icon-button class=\"mcc-timer-picker-hours\" [ngClass]=\"{ 'mcc-active': focus === 'hour' }\"\n                (click)=\"focus = 'hour'\">\n         <span><span *ngIf=\"needsSpacer\">&nbsp;&nbsp;</span>{{ hour }}</span>\n        </button>\n        <span class=\"mcc-timer-picker-separator\">:</span>\n        <button mat-icon-button class=\"mcc-timer-picker-minutes\" [ngClass]=\"{ 'mcc-active': focus === 'min' }\"\n                (click)=\"focus = 'min'\">\n          <span>{{ minute }}</span>\n        </button>\n\n        <div class=\"mcc-timer-picker-am-pm\" *ngIf=\"format === '12'\">\n          <button mat-icon-button [ngClass]=\"{ 'mcc-active': period === 'am' }\" (click)=\"changePeriod('am')\">\n            AM\n          </button>\n          <button mat-icon-button [ngClass]=\"{ 'mcc-active': period === 'pm' }\" (click)=\"changePeriod('pm')\">\n            PM\n          </button>\n        </div>\n      </div>\n    </div>\n\n    <div class=\"mcc-timer-picker-content\">\n\n      <div class=\"mcc-timer-picker-clock\">\n        <div class=\"mcc-timer-picker-dot\"></div>\n        <div class=\"mcc-timer-picker-line\" [ngClass]=\"getSelectedClass()\"></div>\n        <ng-container *ngFor=\"let option of clock$ | async;let i = index;\">\n          <button mat-icon-button class=\"mcc-timer-picker-option\" [ngClass]=\"{\n          'mcc-timer-picker-option-selected': focus === 'hour' && hour == option || focus === 'min' && minute === option }\"\n            [id]=\"'option-'+i\" (click)=\"select(option)\" [disabled]=\"isOptionDisabled(option)\">\n            {{ option }}\n          </button>\n\n        </ng-container>\n\n        <ng-container *ngIf=\"format === '24' && focus === 'hour'\">\n          <ng-container *ngFor=\"let option of hours24; let i = index;\">\n            <button mat-icon-button class=\"mcc-timer-picker-option hours\" [ngClass]=\"{\n              'mcc-timer-picker-option-selected': hour == option}\"\n                    [id]=\"'option-hour-'+i\" (click)=\"select(option)\" [disabled]=\"isOptionDisabled(option)\">\n              {{ option }}\n            </button>\n          </ng-container>\n        </ng-container>\n      </div>\n\n    </div>\n\n    <div *ngIf=\"!hideButtons\" class=\"mcc-timer-picker-actions\">\n      <div style=\"flex: 1 auto;\"></div>\n      <button mat-button role=\"button\" aria-label=\"Cancel\" (click)=\"cancelSelection()\">\n        {{ btnCancel }}\n      </button>\n      <button mat-button role=\"button\" aria-label=\"Confirm\" (click)=\"confirmSelectedTime()\">\n        {{ btnConfirm }}\n      </button>\n    </div>\n\n  </div>\n</ng-template>\n",
                    preserveWhitespaces: false,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [".mcc-timer-picker-overlay{background-color:#fff;border-radius:4px;font-family:Roboto,sans-serif;width:290px}.mcc-timer-picker-header{background:#00796b;border-top-left-radius:4px;border-top-right-radius:4px;box-sizing:border-box;display:flex;justify-content:center;padding:4px 0;width:100%}.mcc-timer-picker-header .mcc-timer-picker-header-clock{align-items:center;display:flex}.mcc-timer-picker-hours,.mcc-timer-picker-minutes{color:hsla(0,0%,100%,.3);font-size:50px;font-weight:400;height:63px;width:63px}.mcc-timer-picker-hours.mcc-standalone,.mcc-timer-picker-minutes.mcc-standalone{text-align:right}.mcc-timer-picker-hours.mcc-active,.mcc-timer-picker-minutes.mcc-active{color:#fff}.mcc-timer-picker-24hours{color:hsla(0,0%,100%,.3);font-size:50px;font-weight:400;height:63px;width:63px}.mcc-timer-picker-24hours.mcc-standalone{text-align:right}.mcc-timer-picker-24hours.mcc-active{color:#fff}.mcc-timer-picker-separator{color:hsla(0,0%,100%,.3);font-size:43px;font-weight:400}.mcc-timer-picker-am-pm{display:flex;flex-direction:column}.mcc-timer-picker-am-pm button{color:hsla(0,0%,100%,.3);font-size:12px;font-weight:400;height:25px;line-height:25px;width:25px}.mcc-timer-picker-am-pm button.mcc-active{color:#fff}.mcc-timer-picker-content{height:260px;padding:15px 0 5px;width:inherit}.mcc-timer-picker-clock{background-color:#eee;border-radius:50%;height:250px;margin:0 auto;position:relative;text-align:center;width:250px}.mcc-timer-picker-clock .mcc-timer-picker-dot{background-color:#00796b;border-radius:50%;height:10px;left:120px;position:absolute;top:120px;width:10px}.mcc-timer-picker-clock .mcc-timer-picker-line{background-color:#00796b;height:100px;left:124px;position:absolute;top:10%;transform-origin:50% 100%;width:2px}.mcc-timer-picker-clock .mcc-timer-picker-line.hour-format-24{height:75px;top:20%}.mcc-timer-picker-clock .mcc-timer-picker-line.selected-index-0{transform:rotate(0deg)}.mcc-timer-picker-clock .mcc-timer-picker-line.selected-index-1{transform:rotate(327deg)}.mcc-timer-picker-clock .mcc-timer-picker-line.selected-index-2{transform:rotate(30deg)}.mcc-timer-picker-clock .mcc-timer-picker-line.selected-index-3{transform:rotate(300deg)}.mcc-timer-picker-clock .mcc-timer-picker-line.selected-index-4{transform:rotate(60deg)}.mcc-timer-picker-clock .mcc-timer-picker-line.selected-index-5{transform:rotate(270deg)}.mcc-timer-picker-clock .mcc-timer-picker-line.selected-index-6{transform:rotate(90deg)}.mcc-timer-picker-clock .mcc-timer-picker-line.selected-index-7{transform:rotate(240deg)}.mcc-timer-picker-clock .mcc-timer-picker-line.selected-index-8{transform:rotate(120deg)}.mcc-timer-picker-clock .mcc-timer-picker-line.selected-index-9{transform:rotate(210deg)}.mcc-timer-picker-clock .mcc-timer-picker-line.selected-index-10{transform:rotate(150deg)}.mcc-timer-picker-clock .mcc-timer-picker-line.selected-index-11{transform:rotate(180deg)}.mcc-timer-picker-clock .mcc-timer-picker-option{position:absolute}.mcc-timer-picker-clock .mcc-timer-picker-option.hours.mat-icon-button{font-size:70%;height:26px;line-height:10px;width:26px}.mcc-timer-picker-clock .mcc-timer-picker-option.hours#option-hour-0{left:112px;top:45px}.mcc-timer-picker-clock .mcc-timer-picker-option.hours#option-hour-1{left:80px;top:57px}.mcc-timer-picker-clock .mcc-timer-picker-option.hours#option-hour-2{right:80px;top:57px}.mcc-timer-picker-clock .mcc-timer-picker-option.hours#option-hour-3{left:57px;top:81px}.mcc-timer-picker-clock .mcc-timer-picker-option.hours#option-hour-4{right:57px;top:81px}.mcc-timer-picker-clock .mcc-timer-picker-option.hours#option-hour-5{left:45px;top:112px}.mcc-timer-picker-clock .mcc-timer-picker-option.hours#option-hour-6{right:45px;top:112px}.mcc-timer-picker-clock .mcc-timer-picker-option.hours#option-hour-7{bottom:81px;left:57px}.mcc-timer-picker-clock .mcc-timer-picker-option.hours#option-hour-8{bottom:81px;right:57px}.mcc-timer-picker-clock .mcc-timer-picker-option.hours#option-hour-9{bottom:57px;left:80px}.mcc-timer-picker-clock .mcc-timer-picker-option.hours#option-hour-10{bottom:57px;right:80px}.mcc-timer-picker-clock .mcc-timer-picker-option.hours#option-hour-11{bottom:45px;left:112px}.mcc-timer-picker-clock .mcc-timer-picker-option.mcc-timer-picker-option-selected{background-color:#00796b;color:#fff}.mcc-timer-picker-clock .mcc-timer-picker-option#option-0{left:105px;top:0}.mcc-timer-picker-clock .mcc-timer-picker-option#option-1{left:52px;top:15px}.mcc-timer-picker-clock .mcc-timer-picker-option#option-2{right:52px;top:16px}.mcc-timer-picker-clock .mcc-timer-picker-option#option-3{left:16px;top:52px}.mcc-timer-picker-clock .mcc-timer-picker-option#option-4{right:16px;top:52px}.mcc-timer-picker-clock .mcc-timer-picker-option#option-5{left:0;top:105px}.mcc-timer-picker-clock .mcc-timer-picker-option#option-6{right:0;top:105px}.mcc-timer-picker-clock .mcc-timer-picker-option#option-7{bottom:52px;left:16px}.mcc-timer-picker-clock .mcc-timer-picker-option#option-8{bottom:52px;right:16px}.mcc-timer-picker-clock .mcc-timer-picker-option#option-9{bottom:16px;left:52px}.mcc-timer-picker-clock .mcc-timer-picker-option#option-10{bottom:16px;right:52px}.mcc-timer-picker-clock .mcc-timer-picker-option#option-11{bottom:0;left:105px}.mcc-timer-picker-actions{display:flex;padding:4px}.mcc-timer-picker-actions button{text-transform:uppercase}mat-icon-button{height:30px;line-height:30px;width:30px}"]
                },] }
    ];
    MccTimerPickerComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef }
    ]; };
    MccTimerPickerComponent.propDecorators = {
        hideButtons: [{ type: core.Input }],
        format: [{ type: core.Input, args: ['mccTimerPickerFormat',] }],
        min: [{ type: core.Input, args: ['mccTimerPickerMin',] }],
        max: [{ type: core.Input, args: ['mccTimerPickerMax',] }],
        btnCancel: [{ type: core.Input }],
        btnConfirm: [{ type: core.Input }],
        selected: [{ type: core.Output }]
    };

    var MccTimerPickerOriginDirective = /** @class */ (function () {
        /**
         * Reference to the element on which the directive is applied.
         */
        function MccTimerPickerOriginDirective(elementRef, renderer) {
            this.elementRef = elementRef;
            this.renderer = renderer;
            /**
             * Emit changes from the origin
             */
            this.change = new rxjs.BehaviorSubject('');
            /**
             * Emit changes from the origin
             */
            this.hasFocus = new core.EventEmitter();
        }
        MccTimerPickerOriginDirective.prototype.onFocus = function () {
            this.hasFocus.emit();
        };
        /**
         * This method will be called by the forms API to write to the view when
         * programmatic (model -> view) changes are requested.
         */
        MccTimerPickerOriginDirective.prototype.writeValue = function (time) {
            this.renderer.setProperty(this.elementRef.nativeElement, 'value', time);
            this.change.next(time);
            if (this.propagateChanges) {
                this.propagateChanges(time);
            }
        };
        /**
         * This method will be called by the time picker
         */
        MccTimerPickerOriginDirective.prototype.writeValueFromTimerPicker = function (time) {
            this.renderer.setProperty(this.elementRef.nativeElement, 'value', time);
            this.propagateChanges(time);
        };
        /**
         * This method will be called from origin whe key is up
         */
        MccTimerPickerOriginDirective.prototype.writeValueFromKeyup = function (time) {
            this.change.next(time);
            this.propagateChanges(time);
        };
        /**
         * This is called by the forms API on initialization so it can update the
         * form model when values propagate from the view (view -> model).
         * @param fn any
         */
        MccTimerPickerOriginDirective.prototype.registerOnChange = function (fn) {
            this.propagateChanges = fn;
        };
        /**
         * This is called by the forms API on initialization so it can update the form model on blur
         * @param fn any
         */
        MccTimerPickerOriginDirective.prototype.registerOnTouched = function (fn) { };
        /**
         * called by the forms API when the control status changes to or from "DISABLED"
         * @param isDisabled boolean
         */
        MccTimerPickerOriginDirective.prototype.setDisabledState = function (isDisabled) {
            this.renderer.setProperty(this.elementRef.nativeElement, 'disabled', isDisabled);
        };
        return MccTimerPickerOriginDirective;
    }());
    MccTimerPickerOriginDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[mccTimerPickerOrigin], [mcc-timer-picker-origin]',
                    exportAs: 'mccTimerPickerOrigin',
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return MccTimerPickerOriginDirective; }),
                            multi: true,
                        },
                    ],
                },] }
    ];
    MccTimerPickerOriginDirective.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.Renderer2 }
    ]; };
    MccTimerPickerOriginDirective.propDecorators = {
        change: [{ type: core.Output }],
        hasFocus: [{ type: core.Output }],
        onFocus: [{ type: core.HostListener, args: ['focus',] }]
    };
    var MccConnectedTimerPickerDirective = /** @class */ (function () {
        function MccConnectedTimerPickerDirective(timerPicker, changeDetectorRef) {
            this.timerPicker = timerPicker;
            this.changeDetectorRef = changeDetectorRef;
            this.timerPicker.connected = true;
        }
        MccConnectedTimerPickerDirective.prototype.ngAfterViewInit = function () {
            if (!this._timerPickerSub) {
                this.timerPicker.trigger = this.origin;
                this._attachTimerPicker();
            }
        };
        MccConnectedTimerPickerDirective.prototype.ngOnDestroy = function () {
            if (this._originFocus && !this._originFocus.closed) {
                this._originFocus.unsubscribe();
            }
            if (this._timerPickerSub && !this._timerPickerSub.closed) {
                this._timerPickerSub.unsubscribe();
            }
        };
        /**
         * Attach the timer picker to origin element (input)
         */
        MccConnectedTimerPickerDirective.prototype._attachTimerPicker = function () {
            var _this = this;
            this._originFocus = this.origin.hasFocus.subscribe(function () {
                _this.timerPicker.focus = 'hour';
                _this.timerPicker.isOpen = true;
                _this.changeDetectorRef.detectChanges();
            });
            this._timerPickerSub = this.timerPicker.selected.subscribe(function (value) { return _this.origin.writeValueFromTimerPicker(value); });
        };
        return MccConnectedTimerPickerDirective;
    }());
    MccConnectedTimerPickerDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[mccConnectedTimerPicker], [mcc-connected-timer-picker]',
                    exportAs: 'mccConnectedTimerPicker',
                },] }
    ];
    MccConnectedTimerPickerDirective.ctorParameters = function () { return [
        { type: MccTimerPickerComponent },
        { type: core.ChangeDetectorRef }
    ]; };
    MccConnectedTimerPickerDirective.propDecorators = {
        origin: [{ type: core.Input, args: ['mccConnectedTimerPickerOrigin',] }]
    };

    var MccTimerPickerModule = /** @class */ (function () {
        function MccTimerPickerModule() {
        }
        return MccTimerPickerModule;
    }());
    MccTimerPickerModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, portal.PortalModule, overlay.OverlayModule, button.MatButtonModule],
                    declarations: [
                        MccTimerPickerComponent,
                        MccTimerPickerOriginDirective,
                        MccConnectedTimerPickerDirective,
                    ],
                    exports: [
                        MccTimerPickerComponent,
                        MccTimerPickerOriginDirective,
                        MccConnectedTimerPickerDirective,
                    ],
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.HOURS = HOURS;
    exports.HOURS24 = HOURS24;
    exports.MINUTES = MINUTES;
    exports.MccConnectedTimerPickerDirective = MccConnectedTimerPickerDirective;
    exports.MccTimerPickerComponent = MccTimerPickerComponent;
    exports.MccTimerPickerModule = MccTimerPickerModule;
    exports.MccTimerPickerOriginDirective = MccTimerPickerOriginDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=material-community-components-timer-picker.umd.js.map
